VERSION 5.00
Begin VB.Form frmDetail 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Algorithm Detail"
   ClientHeight    =   2610
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4245
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmDetail.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   MouseIcon       =   "frmDetail.frx":000C
   ScaleHeight     =   174
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   283
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrFinish 
      Enabled         =   0   'False
      Interval        =   1500
      Left            =   1080
      Top             =   120
   End
   Begin VB.Timer tmrStart 
      Enabled         =   0   'False
      Interval        =   1500
      Left            =   600
      Top             =   120
   End
   Begin VB.Timer tmr 
      Enabled         =   0   'False
      Interval        =   15
      Left            =   120
      Top             =   120
   End
End
Attribute VB_Name = "frmDetail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const DataFile = "\Descrip.txt"
Private Const BorderSize = 10

Private Type HotRegionType
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
    URL As String
End Type

Private grph As clsGraphical
Private mstrSortName As String
Private mlngOps As Long
Private mtypHot() As HotRegionType
Private mlngHot As Long
Private mlngActive As Long

Private Sub DrawDescrip(plngAreaLeft As Long, plngAreaBottom As Long)
    Dim lngRight As Long
    Dim lngBottom As Long
    Dim lngNewLine As Long
    Dim lngX As Long
    Dim strDescrip() As String
    Dim lngLine As Long
    Dim strWords() As String
    Dim strWord As String
    Dim lngNextWord As Long
    Dim i As Long
    Dim lngPos As Long
    Dim blnHotLink As Boolean
    Dim blnSpace As Boolean
    Dim lngSpaceWidth As Long
    
    With Me
        lngRight = plngAreaLeft - Margin
        lngBottom = .ScaleHeight - BorderSize
        lngNewLine = .TextHeight("Qg")
        lngSpaceWidth = .TextWidth(" ")
        .CurrentX = BorderSize
        .CurrentY = BorderSize
        strDescrip = Split(LoadDescription(), vbNewLine)
        mlngHot = -1
        For lngLine = 1 To UBound(strDescrip)
            strWords = Split(strDescrip(lngLine), " ")
            For i = 0 To UBound(strWords)
                strWord = strWords(i)
                blnHotLink = (LCase$(Left$(strWord, 5)) = "[url=")
                If blnHotLink Then
                    mlngHot = mlngHot + 1
                    If mlngHot = 0 Then
                        ReDim mtypHot(mlngHot)
                    Else
                        ReDim Preserve mtypHot(mlngHot)
                    End If
                    lngPos = InStr(strWord, "]")
                    With mtypHot(mlngHot)
                        .URL = Mid$(strWord, 6, lngPos - 6)
                        If InStr(.URL, "/") = 0 Then .URL = Replace$(.URL, "_", " ")
                    End With
                    strWord = Mid$(strWord, lngPos + 1)
                    Do Until InStr(LCase$(strWords(i)), "[/url]") <> 0
                        i = i + 1
                        strWord = strWord & " " & strWords(i)
                    Loop
                    lngPos = InStr(LCase$(strWord), "[/url]")
                    strWord = Left$(strWord, lngPos - 1) & Mid$(strWord, lngPos + 6)
                End If
                Select Case .CurrentX
                    Case BorderSize
                        blnSpace = False
                    Case Is > lngRight - .TextWidth(strWord) - lngSpaceWidth
                        blnSpace = False
                        .CurrentX = BorderSize
                        .CurrentY = .CurrentY + lngNewLine
                        If .CurrentY > plngAreaBottom Then lngRight = .ScaleWidth - BorderSize
                    Case Else
                        blnSpace = True
                End Select
                If .CurrentY > lngBottom Then
                    .Height = .Height + lngNewLine * Screen.TwipsPerPixelY
                    lngBottom = lngBottom + lngNewLine
                End If
                If blnSpace Then Print " ";
                If blnHotLink Then
                    mtypHot(mlngHot).Left = .CurrentX
                    mtypHot(mlngHot).Top = .CurrentY
                    If InStr(mtypHot(mlngHot).URL, "/") = 0 Then .ForeColor = RGB(0, 0, 175) Else .ForeColor = vbBlue
                    .FontUnderline = True
                    Print strWord;
                    .ForeColor = vbBlack
                    .FontUnderline = False
                    mtypHot(mlngHot).Right = .CurrentX
                    mtypHot(mlngHot).Bottom = .CurrentY + lngNewLine
                Else
                    Print strWord;
                End If
            Next
            .CurrentX = BorderSize
            .CurrentY = .CurrentY + lngNewLine
            If .CurrentY > plngAreaBottom Then lngRight = .ScaleWidth - BorderSize
            If .CurrentY > lngBottom Then
                .Height = .Height + lngNewLine * Screen.TwipsPerPixelY
                lngBottom = lngBottom + lngNewLine
            End If
            Erase strWords
        Next
        .Top = (Screen.Height - .Height) \ 2
'        Line (BorderSize, BorderSize)-(.ScaleWidth - BorderSize, BorderSize), vbBlack
'        Line Step(0, 0)-(.ScaleWidth - BorderSize, .ScaleHeight - BorderSize), vbBlack
'        Line Step(0, 0)-(BorderSize, .ScaleHeight - BorderSize), vbBlack
'        Line Step(0, 0)-(BorderSize, BorderSize), vbBlack
        .tmrFinish.Enabled = True
    End With
End Sub

Private Sub DrawWindow()
    Dim lngFormLeft As Long
    Dim lngFormTop As Long
    Dim lngFormWidth As Long
    Dim lngFormHeight As Long
    Dim lngExtraWidth As Long
    Dim lngExtraHeight As Long
    Dim lngAreaLeft As Long
    Dim lngAreaTop As Long
    Dim lngAreaWidth As Long
    Dim lngAreaHeight As Long
    Dim lngAreaBottom As Long

    With Me
        .Caption = mstrSortName
        ' Calculate basic dimensions
        lngExtraWidth = .Width - .ScaleWidth * Screen.TwipsPerPixelX
        lngExtraHeight = .Height - .ScaleHeight * Screen.TwipsPerPixelY
        .FontSize = GetFontSize(Me, True)
        lngAreaWidth = .TextWidth("   Linked List sort   ") + Margin * 2
        lngAreaTop = BorderSize + .TextHeight("Qg") \ 3
        lngAreaHeight = .TextHeight("Qg") * 8.5
        lngFormWidth = (lngAreaWidth * 5 + BorderSize * 2) * Screen.TwipsPerPixelX + lngExtraWidth
        lngFormHeight = (lngAreaTop + lngAreaHeight + BorderSize) * Screen.TwipsPerPixelY + lngExtraHeight
        lngFormLeft = (Screen.Width - lngFormWidth) \ 2
        lngFormTop = (Screen.Height - lngFormHeight) \ 2
        Me.Move lngFormLeft, lngFormTop, lngFormWidth, lngFormHeight
        lngAreaLeft = .ScaleWidth - lngAreaWidth - BorderSize
        lngAreaBottom = lngAreaTop + lngAreaHeight
        grph.DefineRegion lngAreaLeft, lngAreaTop, lngAreaWidth, lngAreaHeight, oeAscending, False
    End With
    DrawDescrip lngAreaLeft, lngAreaBottom
End Sub

Private Sub Form_Click()
    Dim i As Long
    
    If mlngHot <> -1 And mlngActive <> -1 Then
        If InStr(mtypHot(mlngActive).URL, "/") = 0 Then
            With mtypHot(mlngActive)
                For i = 1 To MaxAreas
                    If LCase(.URL) = LCase(GetSortName(i)) Then Exit For
                Next
                Me.tmr.Enabled = False
                Me.tmrStart.Enabled = False
                Me.tmrFinish.Enabled = False
                xp.LockWindow Me.hwnd
                Me.Cls
                mstrSortName = .URL
                grph.Algorithm = i
            End With
            DrawWindow
            xp.UnlockWindow
        Else
            xp.OpenURL mtypHot(mlngActive).URL
        End If
    End If
End Sub

Private Sub Form_Load()
    Set grph = New clsGraphical
    grph.InitGraph Me, frmMain.Algorithm, False
    mlngOps = 0
    mstrSortName = grph.SortName
    DrawWindow
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim i As Long
    Dim blnMatch As Boolean
    Dim strSimpleText As String
    
    If mlngHot <> -1 Then
        For i = 0 To mlngHot
            With mtypHot(i)
                If X >= .Left And X <= .Right And Y >= .Top And Y <= .Bottom Then blnMatch = True
            End With
            If blnMatch Then Exit For
        Next
        If blnMatch Then
            mlngActive = i
            strSimpleText = mtypHot(mlngActive).URL
            Me.MousePointer = vbCustom
        Else
            mlngActive = -1
            strSimpleText = " "
            Me.MousePointer = vbDefault
        End If
        With frmMain.stb
            If .SimpleText <> strSimpleText Then .SimpleText = strSimpleText
        End With
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set grph = Nothing
    Erase mtypHot
End Sub

Private Function LoadDescription() As String
    Dim strFile As String
    Dim strData As String
    Dim strAlgorithms() As String
    Dim strLines() As String
    Dim i As Long
    
    LoadDescription = vbNewLine & "No description available."
    strFile = App.Path & DataFile
    If xp.File.Exists(strFile) Then
        strAlgorithms = Split(xp.File.LoadToString(strFile), vbNewLine & vbNewLine & vbNewLine)
        For i = LBound(strAlgorithms) To UBound(strAlgorithms)
            If Left$(strAlgorithms(i), Len(mstrSortName)) = mstrSortName Then
                LoadDescription = strAlgorithms(i)
                Exit For
            End If
        Next
        Erase strAlgorithms
    End If
End Function

Public Sub Redraw()
    xp.LockWindow Me.hwnd
    DrawWindow
    xp.UnlockWindow
End Sub

Private Sub tmr_Timer()
    tmr.Enabled = False
    With grph
        If mlngOps > 0 Then
            .Iterate
            mlngOps = mlngOps - 1
            tmr.Enabled = True
        Else
            .ClearIndicator
            tmrFinish.Enabled = True
        End If
    End With
End Sub

Private Sub tmrFinish_Timer()
    tmrFinish.Enabled = False
    With grph
        .Shuffle
        mlngOps = .Operations
    End With
    tmrStart.Enabled = True
End Sub

Private Sub tmrStart_Timer()
    tmrStart.Enabled = False
    tmr.Enabled = True
End Sub
