VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomct2.ocx"
Begin VB.Form frmLayout 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Layout"
   ClientHeight    =   2835
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5265
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmLayout.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2835
   ScaleWidth      =   5265
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   555
      Left            =   3420
      TabIndex        =   0
      Top             =   360
      Width           =   1495
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   555
      Left            =   3420
      TabIndex        =   1
      Top             =   960
      Width           =   1495
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply"
      Height          =   555
      Left            =   3420
      TabIndex        =   2
      Top             =   1560
      Width           =   1495
   End
   Begin VB.Frame fra 
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2265
      Left            =   347
      TabIndex        =   3
      Top             =   240
      Width           =   2795
      Begin MSComCtl2.UpDown updColumns 
         Height          =   435
         Left            =   1980
         TabIndex        =   8
         TabStop         =   0   'False
         Top             =   1050
         Width           =   240
         _ExtentX        =   423
         _ExtentY        =   767
         _Version        =   393216
         Value           =   1
         OrigLeft        =   2220
         OrigTop         =   240
         OrigRight       =   2460
         OrigBottom      =   675
         Max             =   6
         Min             =   1
         Enabled         =   -1  'True
      End
      Begin MSComCtl2.UpDown updRows 
         Height          =   435
         Left            =   1980
         TabIndex        =   11
         TabStop         =   0   'False
         Top             =   1545
         Width           =   240
         _ExtentX        =   423
         _ExtentY        =   767
         _Version        =   393216
         Value           =   1
         OrigLeft        =   2220
         OrigTop         =   240
         OrigRight       =   2460
         OrigBottom      =   675
         Max             =   4
         Min             =   1
         Enabled         =   -1  'True
      End
      Begin VB.TextBox txtAreas 
         BackColor       =   &H8000000F&
         Enabled         =   0   'False
         Height          =   435
         Left            =   1380
         TabIndex        =   5
         Text            =   "Areas"
         Top             =   405
         Width           =   630
      End
      Begin VB.TextBox txtColumns 
         Height          =   435
         Left            =   1380
         MaxLength       =   1
         TabIndex        =   7
         Text            =   "Cols"
         Top             =   1050
         Width           =   867
      End
      Begin VB.TextBox txtRows 
         Height          =   435
         Left            =   1380
         MaxLength       =   1
         TabIndex        =   10
         Text            =   "Rows"
         Top             =   1545
         Width           =   867
      End
      Begin VB.Label lblAreas 
         Appearance      =   0  'Flat
         Caption         =   "Areas:"
         Enabled         =   0   'False
         ForeColor       =   &H80000008&
         Height          =   390
         Left            =   435
         TabIndex        =   4
         Top             =   450
         Width           =   855
      End
      Begin VB.Label lblColumns 
         Caption         =   "&Cols:"
         Height          =   390
         Left            =   435
         TabIndex        =   6
         Top             =   1095
         Width           =   870
      End
      Begin VB.Label lblRows 
         Caption         =   "&Rows:"
         Height          =   390
         Left            =   435
         TabIndex        =   9
         Top             =   1590
         Width           =   870
      End
   End
End
Attribute VB_Name = "frmLayout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdApply_Click()
    SaveData
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
    If SaveData() Then Unload Me
End Sub

Private Sub Form_Load()
    FormLayout Me
    With Me
        ' Columns
        .txtColumns.Text = frmMain.GridColumns
        .updColumns.BuddyControl = .txtColumns
        .updColumns.SyncBuddy = True
        ' Rows
        .txtRows.Text = frmMain.GridRows
        .updRows.BuddyControl = .txtRows
        .updRows.SyncBuddy = True
        ' Areas
        .txtAreas.Width = .txtColumns.Width
        .txtAreas.Text = frmMain.GridAreas
    End With
End Sub

Private Function SaveData() As Boolean
    Dim lngColumns As Long
    Dim lngRows As Long
    Dim lngAreas As Long
    
    With Me
        lngColumns = Val(.txtColumns.Text)
        lngRows = Val(.txtRows.Text)
        lngAreas = Val(.txtAreas.Text)
    End With
    If lngColumns < 1 Or lngColumns > MaxColumns Then
        MsgBox "Columns must be between 1 and " & MaxColumns, vbInformation, "Notice"
        Me.txtColumns.SetFocus
    ElseIf lngRows < 1 Or lngRows > MaxRows Then
        MsgBox "Rows must be between 1 and " & MaxRows, vbInformation, "Notice"
        Me.txtRows.SetFocus
    ElseIf lngAreas > lngColumns * lngRows Then
        MsgBox "Not enough columns/rows to fit all areas", vbInformation, "Notice"
    Else
        SaveData = True
        frmMain.UpdateLayout lngColumns, lngRows
    End If
End Function

Private Sub txtColumns_Change()
    SelectText Me.txtColumns
End Sub

Private Sub txtColumns_GotFocus()
    SelectText Me.txtColumns
End Sub

Private Sub txtColumns_KeyPress(KeyAscii As Integer)
    With Me.txtColumns
        Select Case KeyAscii
            Case 49 To 48 + MaxColumns: .Text = Chr(KeyAscii)
            Case 43: If Val(.Text) < MaxColumns Then .Text = Val(.Text) + 1
            Case 45: If Val(.Text) > 1 Then .Text = Val(.Text) - 1
        End Select
    End With
    KeyAscii = 0
End Sub

Private Sub txtRows_Change()
    SelectText Me.txtRows
End Sub

Private Sub txtRows_GotFocus()
    SelectText Me.txtRows
End Sub

Private Sub txtRows_KeyPress(KeyAscii As Integer)
    With Me.txtColumns
        Select Case KeyAscii
            Case 49 To 48 + MaxRows: .Text = Chr(KeyAscii)
            Case 43: If Val(.Text) < MaxRows Then .Text = Val(.Text) + 1
            Case 45: If Val(.Text) > 1 Then .Text = Val(.Text) - 1
        End Select
    End With
    KeyAscii = 0
End Sub

Private Sub SelectText(ptxt As TextBox)
    With ptxt
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

Private Sub updColumns_Change()
    Me.txtColumns.SetFocus
End Sub

Private Sub updRows_Change()
    Me.txtRows.SetFocus
End Sub
